-- NewVehicleJointType
-- Specialization to register a new Joint type from the xml-file
--
-- @ Autor  Tobias F. (John Deere 6930 @ 1. Ls-Modschmiede http://landwirtschaftssimulator-mods.de/)
-- @ Last Edit  28/12/2009

NewVehicleJointType = {};

function NewVehicleJointType.prerequisitesPresent(specializations)
    return true;
end;

function NewVehicleJointType:load(xmlFile)
	local i=0;
    while true do
        local baseName = string.format("vehicle.attacherJoints.attacherJoint(%d)", i);
        local index = getXMLString(xmlFile, baseName.. "#index");
        if index == nil then
            break;
        end;		
		local joint = self.attacherJoints[i+1];
		local hasNewJointType = Utils.getNoNil(getXMLBool(xmlFile, baseName.."#hasNewJointType"), false);
		if hasNewJointType then				
			local jointTypeStr = getXMLString(xmlFile, baseName.."#jointType");
			if jointTypeStr ~= nil then
				local jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
				if jointType == nil then
					Vehicle.registerJointType(jointTypeStr);
					print("register Jointtype: " .. jointTypeStr);
					jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
				end;  
				if jointType ~= nil then
					joint.jointType = jointType;    
				end;
			end;		
		end;		
		i = i + 1;
	end;

	local attacherJointCount = i;
	i = 0;
    while true do
        local baseName = string.format("vehicle.trailerAttacherJoints.trailerAttacherJoint(%d)", i);
        local index = getXMLString(xmlFile, baseName.. "#index");
        if index == nil then
            break;
        end;
		
		local joint = self.attacherJoints[attacherJointCount +1+i];
		local hasNewJointType = Utils.getNoNil(getXMLBool(xmlFile, baseName.."#hasNewJointType"), false);
		if hasNewJointType then				
			local jointTypeStr = getXMLString(xmlFile, baseName.."#jointType");
			if jointTypeStr ~= nil then
				local jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
				if jointType == nil then
					Vehicle.registerJointType(jointTypeStr);
					print("register Jointtype: " .. jointTypeStr);
					jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
				end;  
				if jointType ~= nil then
					joint.jointType = jointType;    
				end;
			end;		
		end;	
        i = i+1;
    end;
end;

function NewVehicleJointType:delete()
end;

function NewVehicleJointType:mouseEvent(posX, posY, isDown, isUp, button)
end;

function NewVehicleJointType:keyEvent(unicode, sym, modifier, isDown)
end;

function NewVehicleJointType:update(dt)
end;

function NewVehicleJointType:draw()
end;